; ##############################################################################
; ##############################################################################
; ##############################################################################
; Diese Routine stellt ein ASCII-Zeichen auf dem Display dar.					
ASCII_TEMP:
	push R0
	push R1
	push temp
	push temp1
	push temp8
	push temp9
	push XL
	push XH
	push YL
	push YH
	push ZL
	push ZH

	rcall ASCII_8x12_TEMP

	pop ZH
	pop ZL
	pop YH
	pop YL
	pop XH
	pop XL
	pop temp9
	pop temp8
	pop temp1
	pop temp
	pop R1
	pop R0
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ASCII 8x12 																	
;																				
; ASCII   0...127 (normal)														
; ASCII 128...254 (invers)														
; ASCII       255 (Cursor rechts)												
;																				
ASCII_8x12_TEMP:
	; Cursor rechts ?
	cpi temp,255
	brne ASCII_8x12_TEMP_NO_255 
	rjmp ASCII_8x12_NEW_SPALTE
ASCII_8x12_TEMP_NO_255:
;-------------------------------------------------------------------------------
	; SPACE ?		
	cpi temp,' ' 	;SPACE
	brne ASCII_8x12_TEMP_NO_ZEILENUMBRUCH
	LDS temp1,(adr_GRAFIC_ASCII_CURSOR_SPALTE)
	cpi temp1,0
	brne ASCII_8x12_TEMP_NO_ZEILENUMBRUCH
	ret
ASCII_8x12_TEMP_NO_ZEILENUMBRUCH:
;-------------------------------------------------------------------------------
	; SICHERUNGSKOPIE fr INVERTIERUNG		
	mov temp8,temp
	; FONT-TABELLE initialisieren			
	ldi ZL,  low(FONT_8x12*2)
	ldi ZH, high(FONT_8x12*2)
	andi temp,0b01111111			; 0...127
	ldi temp1,12*2
	MUL temp,temp1
	add ZL,R0
	adc ZH,R1
	; CURSOR auf ZEILE positionieren		
	ldi YL,LOW (adr_VGA_BILDBEREICH)
	ldi YH,HIGH(adr_VGA_BILDBEREICH)

	LDS temp,(adr_GRAFIC_ASCII_CURSOR_ZEILE)
	ldi temp1,12
	mul temp,temp1

	ldi temp1,90
	mul R0,temp1
	add YL,R0
	adc YH,R1
	; CURSOR auf SPALTE positionieren		
	LDS temp,(adr_GRAFIC_ASCII_CURSOR_SPALTE)
	LSL temp
	LSL temp
	add YL,temp
	adc YH,NULL
;-------------------------------------------------------------------------------
	; ASCII aus TABELLE holen				
	ldi temp9,12					; SCHLEIFE					
ASCII_8x12_s1:
	; ASCII write (von oben nach unten)		
	LPM temp, Z+   					; aus Tabelle laden			
	; INVERTIERUNG							
	SBRC temp8,7	
	com temp
	LPM R0, Z+   					; DUMMY aus Tabelle laden	
;-------------------------------------------------------------------------------
	; FARBE							
	LDS R0,(adr_GRAFIC_FARBE)
	mov R1,R0
	SWAP R1
	; 2 PIXEL WRITE (1x SRAM BYTE)	
	clr temp1
	SBRC temp,7
	or temp1,R0
	SBRC temp,6
	or temp1,R1
	ST Y+,temp1						; im BILDSPEICHER speichern	
	; 2 PIXEL WRITE (1x SRAM BYTE)	
	clr temp1
	SBRC temp,5
	or temp1,R0
	SBRC temp,4
	or temp1,R1
	ST Y+,temp1						; im BILDSPEICHER speichern	
	; 2 PIXEL WRITE (1x SRAM BYTE)	
	clr temp1
	SBRC temp,3
	or temp1,R0
	SBRC temp,2
	or temp1,R1
	ST Y+,temp1						; im BILDSPEICHER speichern	
	; 2 PIXEL WRITE (1x SRAM BYTE)	
	clr temp1
	SBRC temp,1
	or temp1,R0
	SBRC temp,0
	or temp1,R1
	ST Y+,temp1						; im BILDSPEICHER speichern	
;-------------------------------------------------------------------------------
	; neue ZEILE					
	ADIW YL,45						
	ADIW YL,45-4					
	dec temp9
	brne ASCII_8x12_s1
;-------------------------------------------------------------------------------
	; TURBO fr diese Zeilen deaktivieren				
	ldi ZL,LOW (adr_VGA_TURBO_BEREICH160)
	ldi ZH,HIGH(adr_VGA_TURBO_BEREICH160)
	LDS temp,(adr_GRAFIC_ASCII_CURSOR_ZEILE)
	ldi temp1,12
	mul temp,temp1
	add ZL,R0
	adc ZH,R1
	ST Z+,NULL
	ST Z+,NULL
	ST Z+,NULL
	ST Z+,NULL
	ST Z+,NULL
	ST Z+,NULL
	ST Z+,NULL
	ST Z+,NULL
	ST Z+,NULL
	ST Z+,NULL
	ST Z+,NULL
	ST Z+,NULL
;-------------------------------------------------------------------------------
ASCII_8x12_NEW_SPALTE:
	; CURSOR-SPALTEN-ZHLER					
	LDS temp,(adr_GRAFIC_ASCII_CURSOR_SPALTE)
	inc temp
	cpi temp,22
	brsh ASCII_8x12_NEW_ZEILE
	STS(adr_GRAFIC_ASCII_CURSOR_SPALTE),temp
	ret
;-------------------------------------------------------------------------------
ASCII_8x12_NEW_ZEILE:
	STS(adr_GRAFIC_ASCII_CURSOR_SPALTE),NULL
	; CURSOR-ZEILEN-ZHLER					
	LDS temp,(adr_GRAFIC_ASCII_CURSOR_ZEILE)
	inc temp
	cpi temp,13+1
	brsh ASCII_8x12_NEW_ANFANG
	STS(adr_GRAFIC_ASCII_CURSOR_ZEILE),temp
	ret
;-------------------------------------------------------------------------------
ASCII_8x12_NEW_ANFANG:
	STS(adr_GRAFIC_ASCII_CURSOR_ZEILE),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_TEXT_Z:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	brne ASCII_TEXT_w
	ret
ASCII_TEXT_w:
	rcall ASCII_TEMP			; Anzeige
	rjmp ASCII_TEXT_Z
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_CURSOR_ZEILE_NEXT:
	LDS temp,(adr_GRAFIC_ASCII_CURSOR_SPALTE)
	tst temp
	brne ASCII_CURSOR_ZEILE_NEXT_RUN
	ret
ASCII_CURSOR_ZEILE_NEXT_RUN:
	LDS temp,(adr_GRAFIC_ASCII_CURSOR_ZEILE)
	inc temp
	STS(adr_GRAFIC_ASCII_CURSOR_ZEILE),temp	; ZEILE	
	STS(adr_GRAFIC_ASCII_CURSOR_SPALTE),NULL; SPALTE
ret
; ##############################################################################
ASCII_CURSOR_ZEILE_0:
	ldi temp,0
	STS(adr_GRAFIC_ASCII_CURSOR_ZEILE),temp	; ZEILE	
	STS(adr_GRAFIC_ASCII_CURSOR_SPALTE),NULL; SPALTE
ret
ASCII_CURSOR_ZEILE_1:
	ldi temp,1
	STS(adr_GRAFIC_ASCII_CURSOR_ZEILE),temp	; ZEILE	
	STS(adr_GRAFIC_ASCII_CURSOR_SPALTE),NULL; SPALTE
ret
ASCII_CURSOR_ZEILE_2:
	ldi temp,2
	STS(adr_GRAFIC_ASCII_CURSOR_ZEILE),temp	; ZEILE	
	STS(adr_GRAFIC_ASCII_CURSOR_SPALTE),NULL; SPALTE
ret
ASCII_CURSOR_ZEILE_3:
	ldi temp,3
	STS(adr_GRAFIC_ASCII_CURSOR_ZEILE),temp	; ZEILE	
	STS(adr_GRAFIC_ASCII_CURSOR_SPALTE),NULL; SPALTE
ret
ASCII_CURSOR_ZEILE_4:
	ldi temp,4
	STS(adr_GRAFIC_ASCII_CURSOR_ZEILE),temp	; ZEILE	
	STS(adr_GRAFIC_ASCII_CURSOR_SPALTE),NULL; SPALTE
ret
ASCII_CURSOR_ZEILE_5:
	ldi temp,5
	STS(adr_GRAFIC_ASCII_CURSOR_ZEILE),temp	; ZEILE	
	STS(adr_GRAFIC_ASCII_CURSOR_SPALTE),NULL; SPALTE
ret
ASCII_CURSOR_ZEILE_6:
	ldi temp,6
	STS(adr_GRAFIC_ASCII_CURSOR_ZEILE),temp	; ZEILE	
	STS(adr_GRAFIC_ASCII_CURSOR_SPALTE),NULL; SPALTE
ret
ASCII_CURSOR_ZEILE_7:
	ldi temp,7
	STS(adr_GRAFIC_ASCII_CURSOR_ZEILE),temp	; ZEILE	
	STS(adr_GRAFIC_ASCII_CURSOR_SPALTE),NULL; SPALTE
ret
ASCII_CURSOR_ZEILE_8:
	ldi temp,8
	STS(adr_GRAFIC_ASCII_CURSOR_ZEILE),temp	; ZEILE	
	STS(adr_GRAFIC_ASCII_CURSOR_SPALTE),NULL; SPALTE
ret
ASCII_CURSOR_ZEILE_9:
	ldi temp,9
	STS(adr_GRAFIC_ASCII_CURSOR_ZEILE),temp	; ZEILE	
	STS(adr_GRAFIC_ASCII_CURSOR_SPALTE),NULL; SPALTE
ret
ASCII_CURSOR_ZEILE_10:
	ldi temp,10
	STS(adr_GRAFIC_ASCII_CURSOR_ZEILE),temp	; ZEILE	
	STS(adr_GRAFIC_ASCII_CURSOR_SPALTE),NULL; SPALTE
ret
ASCII_CURSOR_ZEILE_11:
	ldi temp,11
	STS(adr_GRAFIC_ASCII_CURSOR_ZEILE),temp	; ZEILE	
	STS(adr_GRAFIC_ASCII_CURSOR_SPALTE),NULL; SPALTE
ret
ASCII_CURSOR_ZEILE_12:
	ldi temp,12
	STS(adr_GRAFIC_ASCII_CURSOR_ZEILE),temp	; ZEILE	
	STS(adr_GRAFIC_ASCII_CURSOR_SPALTE),NULL; SPALTE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_FRAGEZEICHEN:
	ldi temp,'?'	; ?
	jmp ASCII_TEMP
ASCII_GRD:
	ldi temp,''	; %
	jmp ASCII_TEMP
ASCII_PROZENT:
	ldi temp,'%'	; %
	jmp ASCII_TEMP
ASCII_KOMMA:
	ldi temp,','	; ,
	jmp ASCII_TEMP
ASCII_PUNKT:
	ldi temp,'.'	; .
	jmp ASCII_TEMP
ASCII_DOPPEL_PUNKT:
	ldi temp,':'	; :
	jmp ASCII_TEMP
ASCII_DOPPEL_PUNKT_SPACE:
	ldi temp,':'	; : 
	call ASCII_TEMP
	ldi temp,' '
	jmp ASCII_TEMP
ASCII_PLUS:	
	ldi temp,'+'	; +
	jmp ASCII_TEMP
ASCII_MINUS:
	ldi temp,'-'	; -
	jmp ASCII_TEMP
ASCII_SCHRAEGSTRICH:
	ldi temp,'/'	; /
	jmp ASCII_TEMP
; ##############################################################################
ASCII_UNTERSTRICH2:
	ldi temp,'_'
	call ASCII_TEMP
ASCII_UNTERSTRICH:
	ldi temp,'_'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_LEER20:
	ldi temp,255
	call ASCII_TEMP
ASCII_LEER19:
	ldi temp,255
	call ASCII_TEMP
ASCII_LEER18:
	ldi temp,255
	call ASCII_TEMP
ASCII_LEER17:
	ldi temp,255
	call ASCII_TEMP
ASCII_LEER16:
	ldi temp,255
	call ASCII_TEMP
ASCII_LEER15:
	ldi temp,255
	call ASCII_TEMP
ASCII_LEER14:
	ldi temp,255
	call ASCII_TEMP
ASCII_LEER13:
	ldi temp,255
	call ASCII_TEMP
ASCII_LEER12:
	ldi temp,255
	call ASCII_TEMP
ASCII_LEER11:
	ldi temp,255
	call ASCII_TEMP
ASCII_LEER10:
	ldi temp,255
	call ASCII_TEMP
ASCII_LEER9:
	ldi temp,255
	call ASCII_TEMP
ASCII_LEER8:
	ldi temp,255
	call ASCII_TEMP
ASCII_LEER7:
	ldi temp,255
	call ASCII_TEMP
ASCII_LEER6:
	ldi temp,255
	call ASCII_TEMP
ASCII_LEER5:
	ldi temp,255
	call ASCII_TEMP
ASCII_LEER4:
	ldi temp,255
	call ASCII_TEMP
ASCII_LEER3:
	ldi temp,255
	call ASCII_TEMP
ASCII_LEER2:
	ldi temp,255
	call ASCII_TEMP
ASCII_LEER:
	ldi temp,255
	jmp ASCII_TEMP
; ##############################################################################
ASCII_SPACE10:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE9:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE8:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE7:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE6:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE5:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE4:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE3:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE2:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE:
	ldi temp,' '
	jmp ASCII_TEMP
; ##############################################################################
ASCII_00:
	ldi temp,0
	jmp ASCII_TEMP
ASCII_01:
	ldi temp,1
	jmp ASCII_TEMP
ASCII_02:
	ldi temp,2
	jmp ASCII_TEMP
ASCII_03:
	ldi temp,3
	jmp ASCII_TEMP
ASCII_04:
	ldi temp,4
	jmp ASCII_TEMP
ASCII_05:
	ldi temp,5
	jmp ASCII_TEMP
ASCII_06:
	ldi temp,6
	jmp ASCII_TEMP
ASCII_07:
	ldi temp,7
	jmp ASCII_TEMP
ASCII_08:
	ldi temp,8
	jmp ASCII_TEMP
ASCII_09:
	ldi temp,9
	jmp ASCII_TEMP
ASCII_10:
	ldi temp,10
	jmp ASCII_TEMP
; ##############################################################################
ASCII_0:
	ldi temp,'0'
	jmp ASCII_TEMP
ASCII_1:
	ldi temp,'1'
	jmp ASCII_TEMP
ASCII_2:
	ldi temp,'2'
	jmp ASCII_TEMP
ASCII_3:
	ldi temp,'3'
	jmp ASCII_TEMP
ASCII_4:
	ldi temp,'4'
	jmp ASCII_TEMP
ASCII_5:
	ldi temp,'5'
	jmp ASCII_TEMP
ASCII_6:
	ldi temp,'6'
	jmp ASCII_TEMP
ASCII_7:
	ldi temp,'7'
	jmp ASCII_TEMP
ASCII_8:
	ldi temp,'8'
	jmp ASCII_TEMP
ASCII_9:
	ldi temp,'9'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_A:
	ldi temp,'A'
	jmp ASCII_TEMP
ASCII_B:
	ldi temp,'B'
	jmp ASCII_TEMP
ASCII_C:
	ldi temp,'C'
	jmp ASCII_TEMP
ASCII_D:
	ldi temp,'D'
	jmp ASCII_TEMP
ASCII_E:
	ldi temp,'E'
	jmp ASCII_TEMP
ASCII_F:
	ldi temp,'F'
	jmp ASCII_TEMP
ASCII_G:
	ldi temp,'G'
	jmp ASCII_TEMP
ASCII_H:
	ldi temp,'H'
	jmp ASCII_TEMP
ASCII_I:
	ldi temp,'I'
	jmp ASCII_TEMP
ASCII_J:
	ldi temp,'J'
	jmp ASCII_TEMP
ASCII_K:
	ldi temp,'K'
	jmp ASCII_TEMP
ASCII_L:
	ldi temp,'L'
	jmp ASCII_TEMP
ASCII_M:
	ldi temp,'M'
	jmp ASCII_TEMP
ASCII_N:
	ldi temp,'N'
	jmp ASCII_TEMP
ASCII_O:
	ldi temp,'O'
	jmp ASCII_TEMP
ASCII_P:
	ldi temp,'P'
	jmp ASCII_TEMP
ASCII_Q:
	ldi temp,'Q'
	jmp ASCII_TEMP
ASCII_R:
	ldi temp,'R'
	jmp ASCII_TEMP
ASCII_S:
	ldi temp,'S'
	jmp ASCII_TEMP
ASCII_T:
	ldi temp,'T'
	jmp ASCII_TEMP
ASCII_U:
	ldi temp,'U'
	jmp ASCII_TEMP
ASCII_V:
	ldi temp,'V'
	jmp ASCII_TEMP
ASCII_W:
	ldi temp,'W'
	jmp ASCII_TEMP
ASCII_X:
	ldi temp,'X'
	jmp ASCII_TEMP
ASCII_Y:
	ldi temp,'Y'
	jmp ASCII_TEMP
ASCII_Z:
	ldi temp,'Z'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_A_:
	ldi temp,'a'
	jmp ASCII_TEMP
ASCII_B_:
	ldi temp,'b'
	jmp ASCII_TEMP
ASCII_C_:
	ldi temp,'c'
	jmp ASCII_TEMP
ASCII_D_:
	ldi temp,'d'
	jmp ASCII_TEMP
ASCII_E_:
	ldi temp,'e'
	jmp ASCII_TEMP
ASCII_F_:
	ldi temp,'f'
	jmp ASCII_TEMP
ASCII_G_:
	ldi temp,'g'
	jmp ASCII_TEMP
ASCII_H_:
	ldi temp,'h'
	jmp ASCII_TEMP
ASCII_I_:
	ldi temp,'i'
	jmp ASCII_TEMP
ASCII_J_:
	ldi temp,'j'
	jmp ASCII_TEMP
ASCII_K_:
	ldi temp,'k'
	jmp ASCII_TEMP
ASCII_L_:
	ldi temp,'l'
	jmp ASCII_TEMP
ASCII_M_:
	ldi temp,'m'
	jmp ASCII_TEMP
ASCII_N_:
	ldi temp,'n'
	jmp ASCII_TEMP
ASCII_O_:
	ldi temp,'o'
	jmp ASCII_TEMP
ASCII_P_:
	ldi temp,'p'
	jmp ASCII_TEMP
ASCII_Q_:
	ldi temp,'q'
	jmp ASCII_TEMP
ASCII_R_:
	ldi temp,'r'
	jmp ASCII_TEMP
ASCII_S_:
	ldi temp,'s'
	jmp ASCII_TEMP
ASCII_T_:
	ldi temp,'t'
	jmp ASCII_TEMP
ASCII_U_:
	ldi temp,'u'
	jmp ASCII_TEMP
ASCII_V_:
	ldi temp,'v'
	jmp ASCII_TEMP
ASCII_W_:
	ldi temp,'w'
	jmp ASCII_TEMP
ASCII_X_:
	ldi temp,'x'
	jmp ASCII_TEMP
ASCII_Y_:
	ldi temp,'y'
	jmp ASCII_TEMP
ASCII_Z_:
	ldi temp,'z'
	jmp ASCII_TEMP
; ##############################################################################

