; ##############################################################################
; ##############################################################################
; ##############################################################################
; Pin Change Mask Register														
; PCMSK0: PCINT7  PCINT6  PCINT5  PCINT4 *PCINT3  PCINT2  PCINT1  PCINT0  (PA)	
; PCMSK1: PCINT15 PCINT14 PCINT13 PCINT12 PCINT11 PCINT10 PCINT9  PCINT8  (PB)	
; PCMSK2: PCINT23 PCINT22 PCINT21 PCINT20 PCINT19 PCINT18 PCINT17 PCINT16 (PC)	
; PCMSK3: PCINT31 PCINT30 PCINT29 PCINT28 PCINT27 PCINT26 PCINT25 PCINT24 (PD)	
;																				
; Pin Change Interrupt Control Register											
; PCICR - PCIE3 PCIE2 PCIE1 PCIE0												
PIN_CHANGE_INITIALISIERUNG:
	cbi (EINGANG_A_DDR) ,(EINGANG_A_PIN_NR)	; auf EINGANG	
	sbi (EINGANG_A_PORT),(EINGANG_A_PIN_NR)	; PULL-UP-ON	
	cbi (EINGANG_B_DDR) ,(EINGANG_B_PIN_NR)	; auf EINGANG	
	sbi (EINGANG_B_PORT),(EINGANG_B_PIN_NR)	; PULL-UP-ON	

	ldi temp,(1<<PCINT1)|(1<<PCINT0)
	STS(PCMSK0),temp	; Pin Change Mask Register					

	ldi temp,(1<<PCIE0)
	STS(PCICR),temp		; Pin Change Interrupt Control Register		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; fr 1WIRE																		
PCINTERRUPT0:
	SEI										; INTERRUPTS wieder freigeben (verschachtelter Interrupt)
	SBIC(EINGANG_A_PIN),(EINGANG_A_PIN_NR)	; sofort zurck bei LOW-->HIGH Flanke	
	rjmp PCINTERRUPT0_B	
	STS(adr_IMPULS_AKTIV_A),EINS
	reti
PCINTERRUPT0_B:
	SBIC(EINGANG_B_PIN),(EINGANG_B_PIN_NR)	; sofort zurck bei LOW-->HIGH Flanke	
	reti
	STS(adr_IMPULS_AKTIV_B),EINS
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################


