; TIMER0 8-BIT-TIMER															
;																				
; CS02 CS01 CS00																
;	0 	0	0 	No clock source (Timer/Counter stopped)							
;	0 	0 	1 	clkI/O/(No prescaling)											
; *	0 	1 	0 	clkI/O/8 (From prescaler)										
;	0 	1 	1 	clkI/O/64 (From prescaler)										
;	1 	0 	0 	clkI/O/256 (From prescaler)										
;	1 	0 	1 	clkI/O/1024 (From prescaler)									
;	1 	1 	0 	External clock source on T0 pin. Clock on falling edge.			
;	1 	1 	1 	External clock source on T0 pin. Clock on rising edge.			
;																				
; Mode WGM2 WGM1 WGM0 	Mode 													
; 	0 	0 	0 	 0 		Normal 													
; 	1 	0 	0 	 1 		PWM														
; *	2 	0 	1 	 0 		CTC														
; 	3 	0 	1 	 1 		Fast													
; 	5 	1 	0 	 1 		PWM														
; 	7 	1 	1 	 1 		Fast PWM												
;																				
TIMER0_INITIALISIERUNG_CTC:
	; TCCR0A  Timer/Counter Control Register A		
	ldi temp, (0<<COM0A1)| (1<<COM0A0)|(0<<COM0B1)|(0<<COM0B0)|(1<<WGM01)|(0<<WGM00)
	OUT TCCR0A,temp
	; TCCR0B  Timer/Counter Control Register B		
	ldi temp, (0<<FOC0A)| (0<<FOC0B)|(0<<WGM02)|(0<<CS02)|(1<<CS01)|(0<<CS00)
	OUT TCCR0B,temp
	; TIMSK0  Timer/Counter Interrupt Mask Register
	ldi temp, (0<<OCIE0B)| (0<<OCIE0A)|(0<<TOIE0)
	STS TIMSK0,temp
	; OCR0A  Output Compare Register A				
	ldi temp,(TIMER0_CTC)
	OUT OCR0A,temp
	; STARTWERT										
	OUT TCNT0,NULL
	; auf AUSGANG 									
	;sbi DDRB,PB3	; PIN OC0A
	;sbi DDRB,PB4	; PIN OC0B
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 8-BIT-TIMER																	
;																				
; CS22 CS21 CS20																
;	0 	0 	0 	No clock source (Timer/Counter stopped).						
; 	0 	0 	1 	clkT2S/(No prescaling)											
; *	0 	1 	0 	clkT2S/8 (From prescaler)										
;	0 	1 	1 	clkT2S/32 (From prescaler)										
;	1 	0 	0 	clkT2S/64 (From prescaler)										
;	1 	0 	1 	clkT2S/128 (From prescaler)										
;	1 	1 	0 	clkT2S/256 (From prescaler)										
;	1 	1 	1 	clkT2S/1024 (From prescaler)									
;																				
; ca. 32KHz																		
;																				
TIMER2_INITIALISIERUNG_CTC:
	; TCCR2A  Timer/Counter Control Register A		
	ldi temp, (0<<COM2A1)| (1<<COM2A0)|(0<<COM2B1)|(0<<COM2B0)|(1<<WGM21)|(0<<WGM20)	; PIN TOOGELN	
	STS TCCR2A,temp
	; TCCR2B  Timer/Counter Control Register B		
	ldi temp, (0<<FOC2A)| (0<<FOC2B)|(0<<CS22)|(1<<CS21)|(0<<CS20)
	STS TCCR2B,temp
	; TIMSK2  Timer/Counter Interrupt Mask Register
	ldi temp, (0<<OCIE2B)| (0<<OCIE2A)|(0<<TOIE2)
	STS TIMSK2,temp
	; OCR2A  Output Compare Register A				
	ldi temp,(TIMER2_CTC)
	STS OCR2A,temp
	; auf AUSGANG									
	;sbi DDRD,PD6	; PIN OC2B
	;sbi DDRD,PD7	; PIN OC2A
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 16-BIT-TIMER																	
;																				
; CS32 CS31 CS30																
;   0 	0 	0 	No clock source (Timer/Counter stopped).						
;   0 	0 	1 	clkI/1 (No prescaling)											
; 	0 	1 	0 	clkI/8 (From prescaler)											
; *	0 	1 	1 	clkI/64 (From prescaler)										
; 	1 	0 	0 	clkI/256 (From prescaler)										
; 	1 	0 	1 	clkI/1024 (From prescaler)										
; 	1 	1 	0 	External clock source on Tn pin. Clock on falling edge.			
; 	1 	1 	1 	External clock source on Tn pin. Clock on rising edge.			
;																				
TIMER3_INITIALISIERUNG_CTC:
	; TCCR3A  Timer/Counter 3 Control Register A			
	ldi temp, (0<<COM3A1)| (1<<COM3A0)|(0<<COM3B1)|(1<<COM3B0)|(0<<WGM31)|(0<<WGM30)
	STS TCCR3A,temp
	; TCCR3B  Timer/Counter 3 Control Register B			
	ldi temp, (0<<ICNC3)| (0<<ICES3)|(0<<WGM33)|(1<<WGM32)|(0<<CS32)|(1<<CS31)|(1<<CS30)
	STS TCCR3B,temp
	; TCCR3C  Timer/Counter 3 Control Register C			
	ldi temp, (0<<FOC3A)|(0<<FOC3B)
	STS TCCR3C,temp
	; TIMSK3  Timer/Counter3 Interrupt Mask Register		
	ldi temp, (0<<ICIE3)| (0<<OCIE3B)|(1<<OCIE3A)|(0<<TOIE3)
	STS TIMSK3,temp
	; OCR3AH and OCR3AL  Output Compare Register 3 A		
	ldi temp,HIGH(TIMER3_CTC)
	STS OCR3AH,temp
	ldi temp,LOW (TIMER3_CTC)
	STS OCR3AL,temp
	; auf AUSGANG											
	;sbi DDRB,PB6	; PIN OC3A
	;sbi DDRB,PB7	; PIN OC3B
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIM3_COMPA:
	SEI					; INTERRUPTS wieder freigeben (verschachtelter Interrupt)
	push TEMP		    ; Sichern von "TEMP" im Stack			
	in	 TEMP,SREG		; Einlesen des SREG 					
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)	
;-------------------------------------------------------------------------------
	; UHR Vorteiler(20ms)	
	LDS temp,(adr_ss20)
	inc temp
	cpi temp,50
	brsh ZEIT_ss
	STS(adr_ss20),temp
	rjmp TIM3_UHR_FERTIG
;-------------------------------------------------------------------------------
; SEKUNDEN																		
ZEIT_ss:
	STS(adr_ss20),NULL

	STS(adr_FREIGABE_DIAGRAMM_ZEICHNEN),EINS		; Diagramm 

	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)			; GRN an   
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)			; GELB aus	
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)				; ROT  aus	


	LDS temp,(adr_ss)	; aus SRAM laden			
	inc temp
	cpi temp,60
	brsh ZEIT_MM
	STS (adr_ss),temp	; in SRAM speichern	
	rjmp TIM3_UHR_FERTIG
;-------------------------------------------------------------------------------
; MINUTEN																		
ZEIT_MM:
	STS (adr_ss),NULL	; in SRAM speichern	

	LDS temp,(adr_mm)	; aus SRAM laden	
	inc temp
	cpi temp,60
	brsh ZEIT_HH
	STS (adr_mm),temp	; in SRAM speichern	
	rjmp TIM3_UHR_FERTIG
;-------------------------------------------------------------------------------
; STUNDEN																		
ZEIT_HH:
	STS (adr_mm),NULL	; in SRAM speichern	

	STS(adr_FREIGABE_DIAGRAMM_SCHIEBEN),EINS		; Diagramm schieben

	LDS temp,(adr_hh)	; aus SRAM laden	
	inc temp
	cpi temp,24
	brsh ZEIT_TAG
	STS (adr_hh),temp	; in SRAM speichern	
	rjmp TIM3_UHR_FERTIG
;-------------------------------------------------------------------------------
; TAG																			
ZEIT_TAG:
	STS (adr_hh),NULL	; in SRAM speichern	
;-------------------------------------------------------------------------------
TIM3_UHR_FERTIG:
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)		
	out	SREG,TEMP		; Wiederherstellen von SREG				
	pop	TEMP			; Wiederherstellen von "TEMP"			
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################


