;																		
;																		
; Dieses Assembler-Programm	generiert ein VGA-SIGNAL					
;																		
; 640x480 - 60HZ 														
; 																		
; 180x160 PIXEL															
;																		
; ATmega1284P-22MHz (bertaktet mit 10%)								
;																		
; AVR-STUDIO 4															
; Bernhard.Erfurt@gmx.de												
; VERSION: 08/2015														
;																		

;																		
; GRN leuchtet: alle-ok und alles schn								
; GELB leuchtet: Impuls erkannt											
; ROT  leuchtet: 														
;																		

;																		
; Blinken die LEDs, das ist nicht gut !									
; ROT blinkt: 				Fehler im Programmcheck						
; ROT+GELB blinken: 		WDR-Zeitberschreitung						
; ROT+GELB+GRN blinken: 	unkorrekter Interruptaufruf					
;																		

;																		
; Die Pixel generiert der PORT-B, ist aber	dadurch komplett belegt		
;																		
; BILDAUFBAU															
;   BSP: PIXEL oben links FARBE WEIS=0b00000111	= SRAM (adr_VGA_BILDBEREICH) 
;																		


; ATmega1284P 									
.include "m1284pdef.inc"
; VERSION										
.equ VERSION								= 1
; KONSTANTEN									
.equ TAKT									= 22000000	; 22 MHz		
; TIMER-0-WERTE	(RESERVE)						
.equ TIMER0_CTC_FREQUENZ					= 10000
.equ TIMER0_N								= 8
.equ TIMER0_CTC								=(TAKT/(2*TIMER0_N*TIMER0_CTC_FREQUENZ))-1
.equ TIMER0_FREQUENZ_BERECHNET				=TAKT*10/(2*(TIMER0_N)*(1+TIMER0_CTC))
; TIMER-1-WERTE	(VGA-BILD)						
.equ TIMER1_CTC_FREQUENZ					= 31496/2
.equ TIMER1_N								= 1
.equ TIMER1_CTC								=(TAKT/(2*TIMER1_N*TIMER1_CTC_FREQUENZ))-1
.equ TIMER1_FREQUENZ_BERECHNET				=TAKT*10/(2*(TIMER1_N)*(1+TIMER1_CTC))
; TIMER-2-WERTE (ca. 32kHz fr Sensor)			
.equ TIMER2_CTC_FREQUENZ					= 32000
.equ TIMER2_N								= 8
.equ TIMER2_CTC								=(TAKT/(2*TIMER2_N*TIMER2_CTC_FREQUENZ))-1
.equ TIMER2_FREQUENZ_BERECHNET				=TAKT*10/(2*(TIMER2_N)*(1+TIMER2_CTC))
; TIMER-3-WERTE (1s Uhr)						
.equ TIMER3_CTC_FREQUENZ					= 25
.equ TIMER3_N								= 64
.equ TIMER3_CTC								=(TAKT/(2*TIMER3_N*TIMER3_CTC_FREQUENZ))-1
.equ TIMER3_FREQUENZ_BERECHNET				=TAKT*10/(2*(TIMER3_N)*(1+TIMER3_CTC))
; VGA-PIXEL										
.equ VGA_Xsitze								= 180
.equ VGA_Ysitze								= 160
.equ VGA_ZEILEN_PRO_PIXEL					= 3
.equ VGA_BYTES_PRO_ZEILE					= 90
; VGA-RGB-DATA-PORT								
.equ RGB_DATA_DDR							= DDRB
.equ RGB_DATA_PORT							= PORTB
.equ R_DATA_PIN_NR							= 0
.equ G_DATA_PIN_NR							= 1
.equ B_DATA_PIN_NR							= 2
.equ H_DATA_PIN_NR							= 3		; Helligkeit
; VGA-V-SYNCHRON(BILDANFANG)					
.equ VSYNC_PIN_NR							= 0
.equ VSYNC_DDR								= DDRD
.equ VSYNC_PORT								= PORTD
; VGA-H-SYNCHRON (ZEILE)						
.equ HSYNC_PIN_NR							= 1
.equ HSYNC_DDR								= DDRD
.equ HSYNC_PORT								= PORTD
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR						= 4
.equ LED_GRUEN_DDR							= DDRD
.equ LED_GRUEN_PORT							= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR						= 5
.equ LED_GELB_DDR							= DDRD
.equ LED_GELB_PORT							= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR							= 6
.equ LED_ROT_DDR							= DDRD
.equ LED_ROT_PORT							= PORTD
; IMPULS EINGANG-A								
.equ EINGANG_A_PIN_NR						= 0
.equ EINGANG_A_DDR							= DDRA
.equ EINGANG_A_PORT							= PORTA
.equ EINGANG_A_PIN							= PINA
; IMPULS EINGANG-B								
.equ EINGANG_B_PIN_NR						= 1
.equ EINGANG_B_DDR							= DDRA
.equ EINGANG_B_PORT							= PORTA
.equ EINGANG_B_PIN							= PINA
; TASTE-A										
.equ TASTE_A_PIN_NR							= 4
.equ TASTE_A_DDR							= DDRC
.equ TASTE_A_PORT							= PORTC
.equ TASTE_A_PIN							= PINC
; TASTE-B										
.equ TASTE_B_PIN_NR							= 5
.equ TASTE_B_DDR							= DDRC
.equ TASTE_B_PORT							= PORTC
.equ TASTE_B_PIN							= PINC
; TASTE-C 										
.equ TASTE_C_PIN_NR							= 6
.equ TASTE_C_DDR							= DDRC
.equ TASTE_C_PORT							= PORTC
.equ TASTE_C_PIN							= PINC
; TASTE-D 										
.equ TASTE_D_PIN_NR							= 7
.equ TASTE_D_DDR							= DDRC
.equ TASTE_D_PORT							= PORTC
.equ TASTE_D_PIN							= PINC
; ERROR-CODES-SYSTEM							
.equ ERROR_FARBE							= 200
; REGISTER												
.def HILFSREGISTER_R0=R0	; wichtiges Rechenregister	
.def HILFSREGISTER_R1=R1	; wichtiges Rechenregister	
.def HILFSREGISTER_R2=R2	; wichtiges Rechenregister	
.def HILFSREGISTER_R3=R3	; wichtiges Rechenregister	
.def HILFSREGISTER_R4=R4	; wichtiges Rechenregister	
.def HILFSREGISTER_R5=R5	; wichtiges Rechenregister	
.def HILFSREGISTER_R6=R6	; wichtiges Rechenregister	
.def HILFSREGISTER_R7=R7	; wichtiges Rechenregister	
.def SREG_KOPIE		= R8	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def temp_KOPIE		= R9	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def YL_KOPIE		= R10	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def YH_KOPIE		= R11	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def ZL_KOPIE		= R12	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def ZH_KOPIE		= R13	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def NULL 			= R14	; ist immer NULL 	
.def EINS 			= R15	; ist immer EINS 	
.def temp 			= R16
.def temp1 			= R17
.def temp2 			= R18
.def temp3 			= R19
.def temp4 			= R20
.def temp5 			= R21
.def temp6 			= R22
.def temp7 			= R23
.def temp8 			= R24
.def temp9 			= R25
; SRAM-BELEGUNG Adr:0x0100-0x40FF(256-16.639=16383)		
.equ adr_DATEN							=SRAM_START+0		
.equ adr_MENUE							=SRAM_START+3		; MENUE						
.equ adr_TASTE							=SRAM_START+4		; TASTEN-WERT				
.equ adr_ERROR_CODE						=SRAM_START+6		; ERROR CODE 				
.equ adr_ERROR_WERT						=SRAM_START+7		; ERROR CODE (WERT)			
.equ adr_WARNUNG_CODE					=SRAM_START+8		; Warnung Code				
.equ adr_WARNUNG_WERT					=SRAM_START+9		; Warnung Code (WERT)		
.equ adr_ENTZERRUNG_KREIS				=SRAM_START+10		; Anpassung Kreis an Bildschirm
.equ adr_ss20							=SRAM_START+100		; 20ms Sekunden				
.equ adr_ss								=SRAM_START+101		; Sekunden					
.equ adr_mm								=SRAM_START+102		; Minuten					
.equ adr_hh								=SRAM_START+103		; Stunden					

.equ adr_FREIGABE_DIAGRAMM_ZEICHNEN		=SRAM_START+110
.equ adr_FREIGABE_DIAGRAMM_SCHIEBEN		=SRAM_START+111

.equ adr_IMPULS_AKTIV_A					=SRAM_START+120
.equ adr_IMPULS_AKTIV_B					=SRAM_START+121
.equ adr_IMPULSE_A						=SRAM_START+122
.equ adr_IMPULSE_B						=SRAM_START+123



.equ adr_GRAFIC_FARBE					=SRAM_START+1100	; 0=wei 1=schwarz			
.equ adr_GRAFIC_PUNKT_GROESSE			=SRAM_START+1101	; PUNKT-GRSSE 0...9		
.equ adr_GRAFIC_ASCII_CURSOR_ZEILE		=SRAM_START+1102	; CURSOR VGA-ZEILE 			
.equ adr_GRAFIC_ASCII_CURSOR_SPALTE		=SRAM_START+1103	; CURSOR-SPALTE (0..		
.equ adr_GRAFIC_X1						=SRAM_START+1104	; X1-KOORDINATEN
.equ adr_GRAFIC_Y1						=SRAM_START+1105	; Y1-KOORDINATEN
.equ adr_GRAFIC_X2						=SRAM_START+1106	; X2-KOORDINATEN
.equ adr_GRAFIC_Y2						=SRAM_START+1107	; Y2-KOORDINATEN
.equ adr_GRAFIC_RADIUS_L				=SRAM_START+1108	; RADIUS					
.equ adr_GRAFIC_RADIUS_H				=SRAM_START+1109	; RADIUS					
.equ adr_GRAFIC_WINKEL_L				=SRAM_START+1110	; WINKEL					
.equ adr_GRAFIC_WINKEL_H				=SRAM_START+1111	; WINKEL					
.equ adr_GRAFIC_ZEIGER_LAENGE			=SRAM_START+1112	; STRECKEN-LNGE			

.equ adr_VGA_TURBO_ON					=SRAM_START+1600
.equ adr_VGA_TURBO_OFF					=SRAM_START+1601
.equ adr_VGA_TURBO_DUMMY				=SRAM_START+1602
.equ adr_VGA_BILDZEILEN_NR_L			=SRAM_START+1603	; BILD-ZEILENNUMMER					
.equ adr_VGA_BILDZEILEN_NR_H			=SRAM_START+1604
.equ adr_VGA_ZEIGER_DATA_L				=SRAM_START+1605	; ZEIGER fr BILD-DATEN				
.equ adr_VGA_ZEIGER_DATA_H				=SRAM_START+1606
.equ adr_VGA_PIXEL_ZEILEN_COUNTER		=SRAM_START+1607	; PIXELZEILE						
.equ adr_VGA_BILD_ZEILE					=SRAM_START+1608
.equ adr_VGA_TURBO_BEREICH160			=SRAM_START+1610

.equ adr_VGA_BILDBEREICH				=SRAM_START+1800		; BILDSPEICHER						
.equ adr_VGA_BILDBEREICH_ENDE			=SRAM_START+1800+14400-1;(180x160/2 = 14.400 Bytes)			

.equ adr_SRAM_CHECK						=SRAM_START+16300		; SRAM CHECK muss immer "S" sein	
.equ adr_SRAM_END						=SRAM_START+16383		; 

;---------------------------------------------------------------------------
.cseg							;Beginn eines Code-Segmentes				
.org 0							;Startadresse=0								
.org 0x0000 rjmp RESET 			 ; Reset									
.org 0x0002 rjmp INTERRUPT_ERROR ;rjmp INT0 ; IRQ0							
.org 0x0004 rjmp INTERRUPT_ERROR ;rjmp INT1 ; IRQ1							
.org 0x0006 rjmp INTERRUPT_ERROR ;rjmp INT2 ; IRQ2							
.org 0x0008 rjmp PCINTERRUPT0 ; PCINT0						
.org 0x000A rjmp INTERRUPT_ERROR ;rjmp PCINT1 ; PCINT1						
.org 0x000C rjmp INTERRUPT_ERROR ;rjmp PCINT2 ; PCINT2						
.org 0x000E rjmp INTERRUPT_ERROR ;rjmp PCINT3 ; PCINT3						
.org 0x0010 jmp WDT 		; Watchdog Timeout								
.org 0x0012 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPA ; Timer2 CompareA			
.org 0x0014 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPB ; Timer2 CompareB			
.org 0x0016 rjmp INTERRUPT_ERROR ;rjmp TIM2_OVF 	; Timer2 Overflow		
.org 0x0018 rjmp INTERRUPT_ERROR ;rjmp TIM1_CAPT ; Timer1 Capture			
.org 0x001A rjmp TIM1_COMPA ; Timer1 CompareA				
.org 0x001C rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPB ; Timer1 CompareB			
.org 0x001E rjmp INTERRUPT_ERROR ;TIM1_OVF 	; Timer1 Overflow				
.org 0x0020 rjmp INTERRUPT_ERROR ;TIM0_COMPA ; Timer0 CompareA				
.org 0x0022 rjmp INTERRUPT_ERROR ;rjmp TIM0_COMPB ; Timer0 CompareB			
.org 0x0024 rjmp INTERRUPT_ERROR ;rjmp TIM0_OVF 	; Timer0 Overflow		
.org 0x0026 rjmp INTERRUPT_ERROR ;rjmp SPI_STC ; SPI Transfer Complete		
.org 0x0028 rjmp INTERRUPT_ERROR ;rjmp USART0_RXC ; USART0 RX Complete		
.org 0x002A rjmp INTERRUPT_ERROR ;rjmp USART0_UDRE ; USART0,UDR Empty		
.org 0x002C rjmp INTERRUPT_ERROR ;rjmp USART0_TXC ; USART0 TX Complete		
.org 0x002E rjmp INTERRUPT_ERROR ;rjmp ANA_COMP ; Analog Comparator			
.org 0x0030 rjmp INTERRUPT_ERROR ;rjmp ADC ; ADC Conversion Complete		
.org 0x0032 rjmp INTERRUPT_ERROR ;rjmp EE_RDY ; EEPROM Ready				
.org 0x0034 rjmp INTERRUPT_ERROR ;rjmp TWI ; 2-wire Serial					
.org 0x0036 rjmp INTERRUPT_ERROR ;rjmp SPM_RDY ; SPM Ready					
.org 0x0038 rjmp INTERRUPT_ERROR ;rjmp USART1_RXC ; USART1 RX Complete		
.org 0x003A rjmp INTERRUPT_ERROR ;rjmp USART1_UDRE ; USART1,UDR Empty		
.org 0x003C rjmp INTERRUPT_ERROR ;rjmp USART1_TXC ; USART1 TX Complete		
.org 0x003E rjmp INTERRUPT_ERROR ;rjmp TIM3_CAPT ; Timer3 Capture			
.org 0x0040 rjmp TIM3_COMPA ; Timer3 CompareA			
.org 0x0042 rjmp INTERRUPT_ERROR ;rjmp TIM3_COMPB ; Timer3 CompareB			
.org 0x0044 rjmp INTERRUPT_ERROR ;rjmp TIM3_OVF 	; Timer3 Overflow		
; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	CLI											; INTERRUPTS sperren	
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an   
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
	call wait_100ms
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus  
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  aus	
	call wait_100ms
	rjmp INTERRUPT_ERROR
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Diese Routine wird bei WDR-Zeitberschreitung aufgerufen, hier knnte man		
; sich z.B. den Fehler anzeigen lasen, oder DATEN in den EEPROM schreiben		
WDT:
	CLI											; INTERRUPTS sperren	
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an   
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
	call wait_1s
WDT_s:
	rjmp WDT_s
; ##############################################################################
; ##############################################################################
; ##############################################################################
;-------------------------------------------------------------------------------
RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM_CLEAR										
	call SRAM_CLEAR
; PORT_CLEAR										
	call PORT_CLEAR
; LED_INITIALISIERUNG										
	call LED_INITIALISIERUNG
; WDR_INITIALISIERUNG										
	call WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR											
;	call NEUSTART_MIT_WDR
; PIN_CHANGE_INITIALISIERUNG								
	call PIN_CHANGE_INITIALISIERUNG
; VGA_PIN_INITIALISIERUNG									
	call VGA_PIN_INITIALISIERUNG
; TASTEN_INITIALISIERUNG									
	call TASTEN_INITIALISIERUNG
; TIMER INITALISIERUNG										
;	call TIMER0_INITIALISIERUNG_CTC	; RESERVE				
	call TIMER1_INITIALISIERUNG_CTC	; VGA-BILD				
;	call TIMER2_INITIALISIERUNG_CTC	; RESERVE				
	call TIMER3_INITIALISIERUNG_CTC	; UHR					
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	; ZEIT				
	ldi temp,23
	STS(adr_hh),temp	; hh	
	ldi temp,59
	STS(adr_mm),temp	; mm	
	ldi temp,45
	STS(adr_ss),temp	; ss	
; 	PROGRAMM_CHECK											
	call PROGRAMM_CHECK
; Interrupts freigeben										
	sei
; ##############################################################################
; ##############################################################################
; ##############################################################################
; EINSCHWINGEN												
	call GRAFIC_CLEAR
	call VGA_TEST_FARBBALKEN
	call WAIT_100ms
	call VGA_TEST_RECHTECK
	call WAIT_100ms
	call ANZEIGE_BEGRUESSUNG
	call WAIT_1s
	call GRAFIC_CLEAR
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR												; Watch-Dog-RESET	
	call TASTEN_ABFRAGE
	call IMPULS_ZAEHLER_A
	call IMPULS_ZAEHLER_B
	call GRAFIC_DIAGRAMM_SCHIEBEN
	call GRAFIC_DIAGRAMM
	call PROGRAMM_CHECK
	call ANZEIGE_ERROR_CODE
	call TASTEN_WAIT
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "VGA_TIMER.asm"					; TIMER							
.include "VGA_EXT_PIN_CHANGE.asm"			; EXT_PIN_CHANGE				
.include "VGA_BILD_MACRO.asm"				; BILDAUFBAU					
.include "VGA_BILD.asm"						; TIMER+BILDAUFBAU				
.include "VGA_ASCII.asm"					; ASCII							
.include "VGA_ANZEIGE.asm"					; ANZEIGE						
.include "VGA_ANZEIGE_ZAHLEN.asm"			; ZAHLEN						
.include "VGA_ANZEIGE_KURZ.asm"				; ANZEIGE						
.include "VGA_GRAFIC.asm"					; GRAFIC allgemein				
.include "VGA_GRAFIC_PUNKT.asm"				; PUNKT							
.include "VGA_GRAFIC_PUNKT_AUF_KREIS.asm"	; PUNKT auf KREIS				
.include "VGA_GRAFIC_LINIE.asm"				; LINIE							
.include "VGA_GRAFIC_RECHTECK.asm"			; RECHTECK						
.include "VGA_GRAFIC_BOX.asm"				; BOX							
.include "VGA_GRAFIC_ZEIGER.asm"			; ZEIGER						
.include "VGA_GRAFIC_KREIS.asm"				; KREIS							
.include "VGA_GRAFIC_SCHIEBEN.asm"			; SCHIEBEN-links-rechts			
.include "VGA_GRAFIC_DIAGRAMM.asm"			; DIAGRAMM						
.include "VGA_FUNKTIONEN.asm"				; FUNKTIONEN					
.include "VGA_GRAFIC_TESTS.asm"				; TESTBILDER					
.include "VGA_SONSTIGES.asm"				; sonstiges						
.include "VGA_TASTEN.asm"					; TASTEN						
.include "VGA_WAIT_22MHZ.asm"				; 22 MHz						
.include "VGA_TABELLE_ASCII_8x12.asm"		; TABELLE (umfangreich)			
.include "VGA_TABELLE_SINUS_COSINUS.asm"	; TABELLE (umfangreich)			
; ##############################################################################
; ##############################################################################
; ##############################################################################
TEXT_BEGRUESSUNG_0:
.db "VGA 640x480 60Hz ",0
TEXT_BEGRUESSUNG_1:
.db " ",0
TEXT_BEGRUESSUNG_2:
.db "180 x 160 PIXEL",0
TEXT_BEGRUESSUNG_3:
.db " ",0
TEXT_BEGRUESSUNG_4:
.db "ASCII 22x13 (8x12) ",0
TEXT_BEGRUESSUNG_5:
.db " ",0
TEXT_BEGRUESSUNG_6:
.db "ATmega1284P 22MHz",0
TEXT_BEGRUESSUNG_7:
.db " ",0
TEXT_BEGRUESSUNG_8:
.db " ",0
TEXT_BEGRUESSUNG_9:
.db " ",0
TEXT_BEGRUESSUNG_10:
.db " ",0
TEXT_BEGRUESSUNG_11:
.db " ",0
TEXT_BEGRUESSUNG_12:
.db "V1 08/2016 ",0
; ##############################################################################################
; ##############################################################################################
; ##############################################################################################
